HDU-2177 取(2堆)石子游戏
取(2堆)石子游戏
威佐夫博弈 + 二分 || 直接打表
一开始真的想半天不知道该如何寻找答案
-
考虑同时减的,通过差值计算本应该的小值 n,然后判断是否比当前的 n 小,小的话直接减
-
每次考虑更改一个,如果是小的那个,更改完肯定是小的,如果是大的那个,更改完有可能比 a 大,也有可能比 a 小,所有一共有 3 种可能的解,但是只可能是唯一的
这一题的数据真的挺弱的,我第一版代码没有考虑 更改后的 b 仍大于 a 的情况,居然还过了
看了看别人的题解,发现这题数据量比较小,可以直接跑一次 \(O(n)\) 的暴力打表
二分版
#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;
const double gold = (sqrt(5.0) + 1.0) / 2.0;
int solve(int x)
{
int l = 0, r = x - 1;
while(l < r)
{
int mid = l + r >> 1;
int now = (x - mid) * gold;
if(now > mid)
l = mid + 1;
else
r = mid;
}
return l;
}
int f(int a, int b)
{
if(a < b) swap(a, b);
return (a - b) * gold;
}
int main()
{
int n, m;
while(cin >> n >> m && (n | m))
{
int x = (m - n) * gold;
if(x == n) cout << 0 << endl;
else
{
cout << 1 << endl;
if(x < n) cout << x << " " << m - (n - x) << endl;
x = solve(n);
int a = x, b = n;
if(a > b) swap(a, b);
if(f(b, a) == x && x < m && a != n) cout << a << " " << b << endl;
x = solve(m);
a = x, b = m;
if(b < a) swap(a, b);
if(f(a, b) == x && x < n && a != n) cout << a << " " << b << endl;
int l = n, r = m - 1;
while(l < r)
{
int mid = l + r >> 1;
if(f(mid, n) < n)
l = mid + 1;
else
r = mid;
}
if(f(n, l) == n && l < m) cout << n << " " << l << endl;
}
}
return 0;
}
打表版
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
using namespace std;
const double gold = (sqrt(5.0) + 1.0) / 2.0;
const int maxn = 1e6 + 10;
int vis[maxn];
int main()
{
for(int i=0; i<maxn; i++) vis[i] = 1e9 + 10;
vis[0] = 0;
int cur = 1;
int tp = 1;
while(tp + cur < maxn)
{
while(vis[tp] != 1e9 + 10) tp++;
vis[tp] = tp + cur;
vis[tp + cur] = tp;
cur++;
}
int a, b;
while(cin >> a >> b && (a | b))
{
int now = (b - a) * gold;
if(now == a) cout << 0 << endl;
else
{
cout << 1 << endl;
if(now < a) cout << now << " " << vis[now] << endl;
if(vis[a] < b)
{
int n = vis[a], m = a;
if(n > m) swap(n, m);
cout << n << " " << m << endl;
}
if(vis[b] < a && a != b)
{
int n = vis[b], m = b;
if(n > m) swap(n, m);
cout << n << " " << m << endl;
}
}
}
return 0;
}